
Core - Bug # 67155

Status: Resolved Priority: Should have
Author: Morton Jonuschat Category: DBAL
Created: 2015-05-26 Assigned To:
Updated: 2015-07-22 Due date:
TYPO3 Version: 7
PHP Version: 5.6
Complexity:
Is Regression: No
Sprint Focus:
Subject: Invalid SQL Query for sys_categories
Description

DBAL/AdoDB Error message:

#1421053336: ADOdb could not run this query: SELECT "uid" FROM "sys_category" WHERE FIND_IN_SET('0', "parent") != 0
OR "parent" = ''

Environment: TYPO3 7.3-dev, PostgreSQL 9.4

How to reproduce: Open the „Backend User Listing” and try to add a new account.

Related issues:
related to Core - Bug # 46271: DB-error with postgreSQL Resolved 2013-03-14
related to Core - Epic # 64459: Make TYPO3 run on PostgreSQL New 2015-01-23
related to Core - Bug # 67172: AdoDB error on editing a page Resolved 2015-05-27

Associated revisions
Revision 14f04a6a - 2015-07-22 18:50 - Morton Jonuschat

[BUGFIX] dbal: Cast field to CHAR for FIND_IN_SET()

Implement explicit casting of fields to a character representation.
Most DBMS are stricter in regard to data type checking and emit an
error when trying to use FIND_IN_SET() on non-text field types.

On the DBAL side of things the DBMS specifics are used to define that
an explicit cast is required for FIND_IN_SET() so that a query including
the CAST statement gets generated.

A PostgreSQL Specific has been added to enable the explicit casting in
conjuction with DBAL. To avoid checking repeatedly if a DBMS has defined
specific requirements a NullSpecific has been implemented that gets used
as a default.

In the DatabaseTreeDataProvider the listFieldQuery() function has been
changed to use an explicit CAST instead of relying on the implicit
cast done by MySQL when comparing it to an empty string.

The SqlParser has been extended with the support for CAST.
Revision a780e46a - 2015-07-22 20:23 - Morton Jonuschat

[BUGFIX] dbal: Cast field to CHAR for FIND_IN_SET()

Implement explicit casting of fields to a character representation.
Most DBMS are stricter in regard to data type checking and emit an
error when trying to use FIND_IN_SET() on non-text field types.

On the DBAL side of things the DBMS specifics are used to define that
an explicit cast is required for FIND_IN_SET() so that a query including
the CAST statement gets generated.

A PostgreSQL Specific has been added to enable the explicit casting in
conjuction with DBAL. To avoid checking repeatedly if a DBMS has defined
specific requirements a NullSpecific has been implemented that gets used
as a default.

In the DatabaseTreeDataProvider the listFieldQuery() function has been
changed to use an explicit CAST instead of relying on the implicit
cast done by MySQL when comparing it to an empty string.

The SqlParser has been extended with the support for CAST.
History
#1 - 2015-05-26 21:27 - Morton Jonuschat

Additional information:
PostgreSQL fails the query with the error message:

ERROR:  function find_in_set(unknown, bigint) does not exist

The function is defined with arguments find_in_set(unknown, bigint)

A find_in_set() on an integer column doesn't make any sense, even on MySQL.

#2 - 2015-05-26 22:31 - Morton Jonuschat

The query originates at \TYPO3\CMS\Core\Tree\TableConfiguration\DatabaseTreeDataProvider::getChildrenUidsFromParentRelation, line #382 where
a query for a child with possibly multiple parents is being created

#3 - 2015-05-28 13:01 - alexis nicolas

The problem seems to be in \TYPO3\CMS\Core\Database\DatabaseConnection:exec_SELECTgetRows().
There, a query is performed but sql_fetch_assoc() returns a 'false' on it.

#4 - 2015-05-28 23:07 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#5 - 2015-05-28 23:16 - Morton Jonuschat

Background information for the Patch under review:

The impact of the explicit cast on MySQL seems very low according to the query profile. The dataset used for the set was a tree consisting of 100.000
nodes, 100 of which were on the top level,
the rest randomly distributed on varying levels of depth.

mysql> SHOW PROFILES;
+----------+------------+-----------------------------------------------------------------------------------------------+
| Query_ID | Duration   | Query                                                                                         |
+----------+------------+-----------------------------------------------------------------------------------------------+
|        1 | 0.03615300 | SELECT uid FROM sys_category WHERE FIND_IN_SET('0', parent) != 0 OR CAST(parent AS CHAR) = '' |
|        2 | 0.03553800 | SELECT uid FROM sys_category WHERE FIND_IN_SET('0', parent) != 0 OR parent = ''               |
+----------+------------+-----------------------------------------------------------------------------------------------+
2 rows in set (0,00 sec)

Using FIND_IN_SET() make indexes unusable so there is no difference according to EXPLAIN for a statement:

mysql> EXPLAIN SELECT uid FROM sys_category WHERE FIND_IN_SET('0', parent) != 0 OR parent = '';
+----+-------------+--------------+-------+-----------------+-----------------+---------+------+--------+--------------------------+
| id | select_type | table        | type  | possible_keys   | key             | key_len | ref  | rows   | Extra                    |
+----+-------------+--------------+-------+-----------------+-----------------+---------+------+--------+--------------------------+
|  1 | SIMPLE      | sys_category | index | category_parent | category_parent | 4       | NULL | 100479 | Using where; Using index |
+----+-------------+--------------+-------+-----------------+-----------------+---------+------+--------+--------------------------+
1 row in set (0,00 sec)

mysql> EXPLAIN SELECT uid FROM sys_category WHERE FIND_IN_SET('0', parent) != 0 OR CAST(parent AS CHAR) = '';
+----+-------------+--------------+-------+---------------+-----------------+---------+------+--------+--------------------------+
| id | select_type | table        | type  | possible_keys | key             | key_len | ref  | rows   | Extra                    |
+----+-------------+--------------+-------+---------------+-----------------+---------+------+--------+--------------------------+
|  1 | SIMPLE      | sys_category | index | NULL          | category_parent | 4       | NULL | 100479 | Using where; Using index |
+----+-------------+--------------+-------+---------------+-----------------+---------+------+--------+--------------------------+
1 row in set (0,01 sec)

#6 - 2015-05-29 08:51 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#7 - 2015-06-08 09:14 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#8 - 2015-06-08 09:19 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#9 - 2015-06-09 18:41 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#10 - 2015-06-17 23:19 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#11 - 2015-07-17 10:33 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#12 - 2015-07-22 19:00 - Morton Jonuschat
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:14f04a6a526ce654c86e7e62bcf4cb09cfca6eb2.

#13 - 2015-07-22 20:06 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/41842

#14 - 2015-07-22 20:29 - Morton Jonuschat
- Status changed from Under Review to Resolved

Applied in changeset commit:a780e46ad709bcf5df9253182c620cec8c748bc4.
